#ifndef BLOCK_H
#define BLOCK_H

#include <map>
#include <vector>
#include <cstdint>
#include <string>
#include "DLList.h"
#include "BlockEdge.h"

namespace crispBis {

struct Vertex;
struct Partition;
struct SuperBlock;

struct Block
{
  DLList<Vertex> *vertices;
  Partition *partition;
  std::map<size_t, SuperBlock*> superBlocks; // a key is an edge label's ID

#ifndef COUNTING_SUCCESSORS
  std::map<float, DLList<Vertex>*> departingSubblocks1, departingSubblocks2;
#else
  std::map<BlockEdge, DLList<Vertex>*> departingSubblocks;
#endif

  Block(DLList<Vertex> *vertices, Partition *partition,
        std::map<size_t, SuperBlock*> &superBlocks);
  ~Block();
  static void createBlock(DLList<Vertex> *vl);
  size_t size() { return vertices->size; };
  std::string str();
  std::string getName();
};

} // namespace crispBis

#endif // BLOCK_H
