#ifndef SUPERBLOCK_H
#define SUPERBLOCK_H

#include <vector>
#include "DLList.h"

namespace crispBis {

struct Block;
struct SuperPartition;

struct SuperBlock {
  std::vector<Block*> blocks;
  SuperPartition* superPartition;
  SuperBlock *next = nullptr;
  SuperBlock *prev = nullptr;

  SuperBlock(SuperPartition* superPartition);
  size_t size() { return blocks.size(); }
  bool compound() { return blocks.size() > 1; }
  Block* smallerBlock();
  void addBlock(Block *b);
  void removeBlock(Block *b);
  static void createSuperBlock(SuperPartition *sp, Block *b, size_t r);
  std::string str();
};

} // namespace crispBis

#endif // SUPERBLOCK_H
