#ifndef VERTEX_H
#define VERTEX_H

#include <map>
#include <vector>
#include "DLList.h"
#include "Collection.h"

namespace crispBis {

struct CrispBis;
struct Block;
struct Edge;

struct Vertex {
  friend struct Collection<Vertex>;

  CrispBis *crispBisInst = nullptr;
  std::map<size_t, float> label; // the key is a vertex label's ID
  bool processed = false;
  Block *block = nullptr;
  std::map<size_t, std::vector<Edge*>> comingEdges;
  // the key of the map comingEdges is an edge label's ID

  Vertex *next = nullptr;
  Vertex *prev = nullptr;

  ~Vertex();

  static Vertex* getVertex(CrispBis *crispBisInst, const std::string ID);
  void addLabel(std::string p, float degree);
  std::string getID();
  std::string str();

  private:
    Vertex() {};
};

} // namespace crispBis

#endif // VERTEX_H
