#include "BlockEdge.h"
#include "CrispBis.h"
#include "DLList.h"
#include "../lanTools.h"
#include <utility>

namespace crispBis {

BlockEdge::BlockEdge(CrispBis *inst, BlockEdge *sbe)
  : crispBisInst(inst), sourceBlockEdge(sbe)
{
  if (inst)
    inst->emptyBlockEdges->add(this);
}

void BlockEdge::pushKey(float d) {
  assert(crispBisInst);
  if (this->empty()) {
    crispBisInst->emptyBlockEdges->remove(this);
    crispBisInst->nonemptyBlockEdges->add(this);
  }

  auto it = this->find(d);
  if (it == this->end())
    this->insert(std::make_pair(d,1));
  else
    it->second++;
}

void BlockEdge::popKey(float d) {
  assert(crispBisInst);
  auto it = this->find(d);
  assert(it != this->end());
  assert(it->second >= 1);
  it->second--;
  if (it->second == 0)
    this->erase(it);

  if (this->empty()) {
    crispBisInst->nonemptyBlockEdges->remove(this);
    crispBisInst->emptyBlockEdges->add(this);
  }
}

float BlockEdge::maxKey() {
  assert(crispBisInst);
  if (this->empty())
    return 0;

  return this->rbegin()->first;
}

} // namespace crispBis

