#include "Edge.h"
#include "CrispBis.h"
#include "Vertex.h"
#include <sstream>

namespace crispBis {

Edge::Edge(size_t r, Vertex *x, Vertex *y, float d, BlockEdge *bE) {
  label = r;
  origin = x;
  destination = y;
  degree = d;
  blockEdge = bE;
  y->comingEdges[label].push_back(this);
}

std::string Edge::str() {
  CrispBis *crispBisInst = origin->crispBisInst;
  std::stringstream buf;
  buf.precision(3);
  buf << "edge("
      << crispBisInst->vertices.getName(origin) << ", "
      << crispBisInst->vertices.getName(destination) << ", "
      << crispBisInst->edgeLabels.getName(label) << ", "
      << degree << ")";
  return buf.str();
}

} // namespace crispBis

