#include "Partition.h"
#include "Block.h"
#include "../lanTools.h"
#include <set>
#include <sstream>

namespace crispBis {

Partition::~Partition() {
  for (auto it = begin(); it != end(); it++)
    DELETE(*it);
}

std::string Partition::str() {
  std::set<std::string> _blocks;
  for (auto it = begin(); it != end(); it++)
    _blocks.insert((*it)->str());

  std::stringstream buf;
  bool first = true;
  for (const std::string &id: _blocks) {
    if (!first)
      buf << "\n";
    first = false;
    buf << id;
  }
  return buf.str();
};

} // namespace crispBis

