#include "SuperPartition.h"
#include "SuperBlock.h"
#include <sstream>

namespace crispBis {

SuperPartition::SuperPartition() {
  compoundSuperBlocks = NEW(DLList<SuperBlock>, DLList<SuperBlock>(true));
  simpleSuperBlocks = NEW(DLList<SuperBlock>, DLList<SuperBlock>(true));
}

SuperPartition::~SuperPartition() {
  DELETE(compoundSuperBlocks);
  DELETE(simpleSuperBlocks);
}

void SuperPartition::addSuperBlock(SuperBlock *sb) {
  if (sb->compound())
    compoundSuperBlocks->add(sb);
  else
    simpleSuperBlocks->add(sb);
}

std::string SuperPartition::str() {
  std::stringstream buf;
  buf << compoundSuperBlocks->str() << "+" << simpleSuperBlocks->str();
  return buf.str();
}

} // namespace crispBis

