#!/usr/bin/bash

totalBlocks=0
elapsed2=0

repeat=3
for (( i=1; i<=$repeat; i++ ))
do
    ./genTest $@ > in.txt
	echo "Generated a test using the parameters $@."

	start_time=$(date +%s.%6N)
    ./crispbis < in.txt > out.txt
	end_time=$(date +%s.%6N)

	blocks=$(wc -l < out.txt)
	echo "$blocks blocks."
	(( totalBlocks += blocks ))

	elapsed=$(echo "scale=6; $end_time - $start_time" | bc)
	elapsed2=$(echo $elapsed2 + $elapsed | bc)

	echo "Executed the C++ version, $elapsed seconds."
	echo "Done the random test #${i}."
done

filename=test_result_for_1_version
for arg in "${@}"
do
    filename="$filename"_$arg
done
echo $(echo "scale=1; $totalBlocks/$repeat" | bc) $(echo "scale=6; $elapsed2/$repeat" | bc) > $filename.txt

