#!/usr/bin/bash

totalBlocks=0
elapsed1=0
elapsed2=0

repeat=3
for (( i=1; i<=$repeat; i++ ))
do
    ./genTest $@ > in.txt
	echo "Generated a test using the parameters $@."

	start_time=$(date +%s.%6N)
    python3 CompCB.py < in.txt > out1.txt
	end_time=$(date +%s.%6N)
	blocks=$(wc -l < out1.txt)
	echo "$blocks blocks."
	(( totalBlocks += blocks ))
	elapsed=$(echo "scale=6; $end_time - $start_time" | bc)
	elapsed1=$(echo $elapsed1 + $elapsed | bc)
	echo "Executed the sophisticated Python version, $elapsed seconds."

	start_time=$(date +%s.%6N)
    ./crispbis < in.txt > out2.txt
	end_time=$(date +%s.%6N)
	elapsed=$(echo "scale=6; $end_time - $start_time" | bc)
	elapsed2=$(echo $elapsed2 + $elapsed | bc)
	echo "Executed the C++ version, $elapsed seconds."

    if !(diff out1.txt out2.txt &> /dev/null); then
		echo "The two versions did not give the same result!"
		exit
	else
	    echo "Done the random test #${i}."
    fi
done

filename=test_result_for_2_versions
for arg in "${@}"
do
    filename="$filename"_$arg
done
echo $(echo "scale=1; $totalBlocks/$repeat" | bc) $(echo "scale=6; $elapsed1/$repeat" | bc) $(echo "scale=6; $elapsed2/$repeat" | bc) > $filename.txt

